Bug 17854 - New Print slip and close button next to Close button
Summary: New Print slip and close button next to Close button
Status: RESOLVED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Patrons (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Christopher Brannon
QA Contact: Testopia
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2017-01-05 22:26 UTC by Christopher Brannon
Modified: 2019-05-30 12:13 UTC (History)
7 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Small patch
Who signed the patch off:
Text to go in the release notes:
Adds a 'Printer' button next to the 'X' (clear) button when viewing a patron record - this allows the librarian to print a slip for the patron and clear their account form the screen to prevent viewing of information by another user or patron.
Version(s) released in:


Attachments
Bug 17854: Adds print/close icon in checkout (3.17 KB, patch)
2018-09-24 20:00 UTC, Christopher Brannon
Details | Diff | Splinter Review
Bug 17854: Adds print/close icon in checkout (3.21 KB, patch)
2018-09-25 19:32 UTC, Michal Denar
Details | Diff | Splinter Review
Bug 17854: Adds print/close icon in checkout (3.21 KB, patch)
2018-10-04 10:02 UTC, Michal Denar
Details | Diff | Splinter Review
Bug 17854: Adds print/close icon in checkout (3.23 KB, patch)
2019-01-27 14:28 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Christopher Brannon 2017-01-05 22:26:22 UTC
Would like to see an enhancement on the clear screen (X) button on patron records.  It would be great if it were replaced with a button with preference settings that would have the following options:

Close
Print Slip and Close
Print Quick Slip and Close

It would also be great if it could have a side action arrow giving you access to the other options that are not defaulted.

This feature would help with staff closing accounts (clearing screen) when done, and making slip printing stand out a little better.  It would also be a streamlined workflow.
Comment 1 Christopher Brannon 2018-09-24 20:00:55 UTC
Created attachment 79342 [details] [review]
Bug 17854: Adds print/close icon in checkout

To Test:
1) Apply Patch.
2) Go to a patron checkout screen (circulation.pl).
3) Note there are no clear screen buttons in the upper right corner of
the checkout window.
4) Turn on the DisplayClearScreenButton preference.
5) Go back to patron checkout.  Note the clear screen button and the new
printer icon next to it.
6) Click the printer icon.  This will trigger a print slip function, and
close the patron screen.
7) Try to arrow back to the previous screen.  Should go to main menu and
not the patron screen, just like the orginal close button (X).
Comment 2 Christopher Brannon 2018-09-24 20:06:52 UTC
I have a patch ready for testing, however, this does not address all my requests.  It does print the slip.  It is the same function as the Print Slip choice.  However, I know this does not address the issue if someone would rather print a quick slip and close.

We could either:

A) add another button next to the new button for a quick slip/close.
or
B) add a dropdown selector next to the button that would choose a default behavior and store the choice in a cookie.


Option B is more complicated and I would need someone else to step in as I don't know a thing about cookies.  I could easily do option A.

Thoughts?
Comment 3 Christopher Brannon 2018-09-24 20:17:51 UTC
BTW, when you load the patch, you will need to:
 
$ yarn build

to update the css. Without it, the button will not be in the correct place or have the correct look.  Sandbox testers will not be able to test without this ability.
Comment 4 Christopher Brannon 2018-09-24 20:20:30 UTC
UPDATED TEST PLAN:
1) Apply Patch.
2) Run yarn build to update the css (Sorry sandbox testers!).
3) Go to a patron checkout screen (circulation.pl).
4) Note there are no clear screen buttons in the upper right corner of
the checkout window.
5) Turn on the DisplayClearScreenButton preference.
6) Go back to patron checkout.  Note the clear screen button and the new
printer icon next to it.
7) Click the printer icon.  This will trigger a print slip function, and
close the patron screen.
8) Try to arrow back to the previous screen.  Should go to main menu and
not the patron screen, just like the orginal close button (X).
Comment 5 Christopher Brannon 2018-09-24 20:21:08 UTC
See Comment 2 for discussion.
Comment 6 Owen Leonard 2018-09-25 12:33:53 UTC
Since the CircAutoPrintQuickSlip includes all the options you want, why not tie that preference to the DisplayClearScreenButton to get what you want? 

IF DisplayClearScreenButton is ON, clicking the clear screen button would trigger the action defined in CircAutoPrintQuickSlip.
Comment 7 Michal Denar 2018-09-25 19:32:49 UTC
Created attachment 79384 [details] [review]
Bug 17854: Adds print/close icon in checkout

To Test:
1) Apply Patch.
2) Go to a patron checkout screen (circulation.pl).
3) Note there are no clear screen buttons in the upper right corner of
the checkout window.
4) Turn on the DisplayClearScreenButton preference.
5) Go back to patron checkout.  Note the clear screen button and the new
printer icon next to it.
6) Click the printer icon.  This will trigger a print slip function, and
close the patron screen.
7) Try to arrow back to the previous screen.  Should go to main menu and
not the patron screen, just like the orginal close button (X).

Signed-off-by: Michal Denar <black23@gmail.com>
Comment 8 Christopher Brannon 2018-09-25 23:33:31 UTC
(In reply to Owen Leonard from comment #6)
> Since the CircAutoPrintQuickSlip includes all the options you want, why not
> tie that preference to the DisplayClearScreenButton to get what you want? 
> 
> IF DisplayClearScreenButton is ON, clicking the clear screen button would
> trigger the action defined in CircAutoPrintQuickSlip.

Man!  I didn't remember that.  Wish someone mentioned it in the almost 2 years this was reported.  I would have gone that route.  But my button was pretty cute!  :)  I'll put this to a discussion and try an alternative patch with that suggestion.  :)  Thanks....OWEN.  :)
Comment 9 Christopher Brannon 2018-09-25 23:39:52 UTC
Actually, I am going to put this back to needs signoff and go back to my question in comment 2.

I don't want to pursue the CircAutoPrintQuickSlip preference, and here is why - It is an all or nothing setting.  As a member of a consortium, this would be a problem.  Not all our libraries have printers.  Not everyone wants to print the same slip.  That particular setting should have been incorporated under the library settings, or modified so that it could be set per library.
Comment 10 Michal Denar 2018-10-04 10:02:33 UTC
Created attachment 79942 [details] [review]
Bug 17854: Adds print/close icon in checkout

To Test:
1) Apply Patch.
2) Go to a patron checkout screen (circulation.pl).
3) Note there are no clear screen buttons in the upper right corner of
the checkout window.
4) Turn on the DisplayClearScreenButton preference.
5) Go back to patron checkout.  Note the clear screen button and the new
printer icon next to it.
6) Click the printer icon.  This will trigger a print slip function, and
close the patron screen.
7) Try to arrow back to the previous screen.  Should go to main menu and
not the patron screen, just like the orginal close button (X).

Signed-off-by: Michal Denar <black23@gmail.com>
Comment 11 Christopher Brannon 2018-11-08 18:57:11 UTC
Setting back to signed off, since no one has anything to say about it.
Comment 12 Katrin Fischer 2019-01-27 14:28:23 UTC
Created attachment 84472 [details] [review]
Bug 17854: Adds print/close icon in checkout

To Test:
1) Apply Patch.
2) Go to a patron checkout screen (circulation.pl).
3) Note there are no clear screen buttons in the upper right corner of
the checkout window.
4) Turn on the DisplayClearScreenButton preference.
5) Go back to patron checkout.  Note the clear screen button and the new
printer icon next to it.
6) Click the printer icon.  This will trigger a print slip function, and
close the patron screen.
7) Try to arrow back to the previous screen.  Should go to main menu and
not the patron screen, just like the orginal close button (X).

Signed-off-by: Michal Denar <black23@gmail.com>
Comment 13 Nick Clemens 2019-01-31 13:37:16 UTC
Awesome work all!

Pushed to master for 19.05
Comment 14 Martin Renvoize 2019-02-01 15:41:48 UTC
Enhancement, will not be backported to 18.11.x series.